diff -r 60363ba041e2 modules/country/CHANGELOG
--- a/modules/country/CHANGELOG	Wed Jun 26 22:06:39 2019 +0200
+++ b/modules/country/CHANGELOG	Wed Jul 24 18:28:49 2019 +0200
@@ -1,3 +1,5 @@
+* Replace XML data by import script
+
 Version 5.2.0 - 2019-05-06
 * Bug fixes (see mercurial logs for details)
 * Remove starting wildcard when searching on codes and numbers
diff -r 60363ba041e2 modules/country/country.py
--- a/modules/country/country.py	Wed Jun 26 22:06:39 2019 +0200
+++ b/modules/country/country.py	Wed Jul 24 18:28:49 2019 +0200
@@ -1,7 +1,9 @@
 # This file is part of Tryton.  The COPYRIGHT file at the top level of
 # this repository contains the full copyright notices and license terms.
 from trytond.model import ModelView, ModelSQL, DeactivableMixin, fields
+from trytond.pool import Pool
 from trytond.pyson import Eval
+from trytond.transaction import Transaction
 from trytond.tools import lstrip_wildcard
 
 __all__ = ['Country', 'Subdivision', 'Zip']
@@ -28,6 +30,11 @@
 
     @classmethod
     def __register__(cls, module_name):
+        pool = Pool()
+        Data = pool.get('ir.model.data')
+        data = Data.__table__()
+        cursor = Transaction().connection.cursor()
+
         super(Country, cls).__register__(module_name)
 
         table = cls.__table_handler__(module_name)
@@ -39,6 +46,10 @@
         # Migration from 3.8: remove required on code
         table.not_null_action('code', 'remove')
 
+        # Migration from 5.2: remove country data
+        cursor.execute(*data.delete(where=(data.module == 'country')
+                & (data.model == cls.__name__)))
+
     @classmethod
     def search_rec_name(cls, name, clause):
         code_value = clause[2]
@@ -202,6 +213,19 @@
         cls._order.insert(0, ('code', 'ASC'))
 
     @classmethod
+    def __register__(cls, module_name):
+        pool = Pool()
+        Data = pool.get('ir.model.data')
+        data = Data.__table__()
+        cursor = Transaction().connection.cursor()
+
+        super().__register__(module_name)
+
+        # Migration from 5.2: remove country data
+        cursor.execute(*data.delete(where=(data.module == 'country')
+                & (data.model == cls.__name__)))
+
+    @classmethod
     def search_rec_name(cls, name, clause):
         return ['OR',
             ('name',) + tuple(clause[1:]),
diff -r 60363ba041e2 modules/country/scripts/trytond_import_countries
--- /dev/null	Thu Jan 01 00:00:00 1970 +0000
+++ b/modules/country/scripts/trytond_import_countries	Wed Jul 24 18:28:49 2019 +0200
@@ -0,0 +1,173 @@
+#!/usr/bin/env python3
+# This file is part of Tryton.  The COPYRIGHT file at the top level of
+# this repository contains the full copyright notices and license terms.
+import gettext
+import os
+import sys
+from argparse import ArgumentParser
+
+import pycountry
+
+try:
+    from progressbar import ProgressBar, Bar, ETA, SimpleProgress
+except ImportError:
+    ProgressBar = None
+
+try:
+    from proteus import Model, config
+except ImportError:
+    prog = os.path.basename(sys.argv[0])
+    sys.exit("proteus must be installed to use %s" % prog)
+
+
+def _progress(iterable):
+    if ProgressBar:
+        pbar = ProgressBar(
+            widgets=[SimpleProgress(), Bar(), ETA()])
+    else:
+        pbar = iter
+    return pbar(iterable)
+
+
+def _get_language_codes():
+    Language = Model.get('ir.lang')
+    languages = Language.find([('translatable', '=', True)])
+    for l in languages:
+        yield l.code
+
+
+def get_countries():
+    Country = Model.get('country.country')
+
+    with config.get_config().set_context(active_test=False):
+        return {c.code: c for c in Country.find([])}
+
+
+def update_countries(countries):
+    print("Update countries")
+    Country = Model.get('country.country')
+
+    records = []
+    for country in _progress(pycountry.countries):
+        code = country.alpha_2
+        if code in countries:
+            record = countries[code]
+        else:
+            record = Country(code=code)
+        record.name = country.name
+        record.code3 = country.alpha_3
+        record.code_numeric = country.numeric
+        records.append(record)
+
+    Country.save(records)
+    return {c.code: c for c in records}
+
+
+def translate_countries(countries):
+    Country = Model.get('country.country')
+
+    current_config = config.get_config()
+    for code in _get_language_codes():
+        try:
+            gnutranslation = gettext.translation(
+                'iso3166', pycountry.LOCALES_DIR, languages=[code])
+        except IOError:
+            continue
+        print("Update countries %s" % code)
+        with current_config.set_context(language=code):
+            records = []
+            for country in _progress(pycountry.countries):
+                record = Country(countries[country.alpha_2].id)
+                record.name = gnutranslation.gettext(country.name)
+                records.append(record)
+            Country.save(records)
+
+
+def get_subdivisions():
+    Subdivision = Model.get('country.subdivision')
+
+    with config.get_config().set_context(active_test=False):
+        return {(s.country.code, s.code): s for s in Subdivision.find([])}
+
+
+def update_subdivisions(countries, subdivisions):
+    print("Update subdivisions")
+    Subdivision = Model.get('country.subdivision')
+
+    records = []
+    for subdivision in _progress(pycountry.subdivisions):
+        code = subdivision.code
+        country_code = subdivision.country_code
+        if (country_code, code) in subdivisions:
+            record = subdivisions[(country_code, code)]
+        else:
+            record = Subdivision(code=code, country=countries[country_code])
+        record.name = subdivision.name
+        record.type = subdivision.type.lower()
+        records.append(record)
+
+    Subdivision.save(records)
+    return {(s.country.code, s.code): s for s in records}
+
+
+def update_subdivisions_parent(subdivisions):
+    print("Update subdivisions parent")
+    Subdivision = Model.get('country.subdivision')
+
+    records = []
+    for subdivision in _progress(pycountry.subdivisions):
+        code = subdivision.code
+        country_code = subdivision.country_code
+        record = subdivisions[(country_code, code)]
+        if subdivision.parent_code:
+            record.parent = subdivisions[
+                (country_code, subdivision.parent_code)]
+        else:
+            record.parent = None
+        records.append(record)
+    Subdivision.save(records)
+
+
+def translate_subdivisions(subdivisions):
+    Subdivision = Model.get('country.subdivision')
+
+    current_config = config.get_config()
+    for code in _get_language_codes():
+        try:
+            gnutranslation = gettext.translation(
+                'iso3166-2', pycountry.LOCALES_DIR, languages=[code])
+        except IOError:
+            continue
+        print("Update subdivisions %s" % code)
+        with current_config.set_context(language=code):
+            records = []
+            for subdivision in _progress(pycountry.subdivisions):
+                record = Subdivision(subdivisions[
+                        (subdivision.country_code, subdivision.code)].id)
+                record.name = gnutranslation.gettext(subdivision.name)
+                records.append(record)
+            Subdivision.save(records)
+
+
+def main(database, config_file=None):
+    config.set_trytond(database, config_file=config_file)
+
+    countries = get_countries()
+    countries = update_countries(countries)
+    translate_countries(countries)
+    subdivisions = get_subdivisions()
+    subdivisions = update_subdivisions(countries, subdivisions)
+    update_subdivisions_parent(subdivisions)
+    translate_subdivisions(subdivisions)
+
+
+if __name__ == '__main__':
+    parser = ArgumentParser()
+    parser.add_argument('-d', '--database', dest='database')
+    parser.add_argument('-c', '--config', dest='config_file',
+        help='the trytond config file')
+
+    args = parser.parse_args()
+    if not args.database:
+        parser.error('Missing database')
+    main(args.database, args.config_file)
diff -r 60363ba041e2 modules/country/setup.py
--- a/modules/country/setup.py	Wed Jun 26 22:06:39 2019 +0200
+++ b/modules/country/setup.py	Wed Jul 24 18:28:49 2019 +0200
@@ -79,7 +79,10 @@
         'trytond.modules.country': (info.get('xml', [])
             + ['tryton.cfg', 'view/*.xml', 'locale/*.po', 'icons/*.svg']),
         },
-    scripts=['scripts/trytond_import_zip'],
+    scripts=[
+        'scripts/trytond_import_countries',
+        'scripts/trytond_import_zip',
+        ],
     classifiers=[
         'Development Status :: 5 - Production/Stable',
         'Environment :: Plugins',
@@ -120,6 +123,7 @@
     python_requires='>=3.5',
     install_requires=requires,
     extras_require={
+        'data': ['pycountry', get_require_version('proteus')],
         'GeoNames': [get_require_version('proteus')],
         },
     dependency_links=dependency_links,
diff -r 60363ba041e2 modules/country/tryton.cfg
--- a/modules/country/tryton.cfg	Wed Jun 26 22:06:39 2019 +0200
+++ b/modules/country/tryton.cfg	Wed Jul 24 18:28:49 2019 +0200
@@ -5,4 +5,3 @@
     res
 xml:
     country.xml
-    data.xml
diff -r 02664e9b5ec6 modules/currency/CHANGELOG
--- a/modules/currency/CHANGELOG	Mon May 06 15:03:00 2019 +0200
+++ b/modules/currency/CHANGELOG	Wed Jul 24 18:28:49 2019 +0200
@@ -1,3 +1,5 @@
+* Replace XML data by import script
+
 Version 5.2.0 - 2019-05-06
 * Bug fixes (see mercurial logs for details)
 
diff -r 02664e9b5ec6 modules/currency/currency.py
--- a/modules/currency/currency.py	Mon May 06 15:03:00 2019 +0200
+++ b/modules/currency/currency.py	Wed Jul 24 18:28:49 2019 +0200
@@ -51,6 +51,11 @@
 
     @classmethod
     def __register__(cls, module_name):
+        pool = Pool()
+        Data = pool.get('ir.model.data')
+        data = Data.__table__()
+        cursor = Transaction().connection.cursor()
+
         super(Currency, cls).__register__(module_name)
 
         table_h = cls.__table_handler__(module_name)
@@ -61,6 +66,10 @@
                 'p_sign_posn', 'n_sign_posn']:
             table_h.not_null_action(col, 'remove')
 
+        # Migration from 5.2: remove country data
+        cursor.execute(*data.delete(where=(data.module == 'currency')
+                & (data.model == cls.__name__)))
+
     @staticmethod
     def default_rounding():
         return Decimal('0.01')
diff -r 02664e9b5ec6 modules/currency/scripts/trytond_import_currencies
--- /dev/null	Thu Jan 01 00:00:00 1970 +0000
+++ b/modules/currency/scripts/trytond_import_currencies	Wed Jul 24 18:28:49 2019 +0200
@@ -0,0 +1,105 @@
+#!/usr/bin/env python3
+# This file is part of Tryton.  The COPYRIGHT file at the top level of
+# this repository contains the full copyright notices and license terms.
+import gettext
+import os
+import sys
+from argparse import ArgumentParser
+
+import pycountry
+from forex_python.converter import CurrencyCodes
+
+try:
+    from progressbar import ProgressBar, Bar, ETA, SimpleProgress
+except ImportError:
+    ProgressBar = None
+
+try:
+    from proteus import Model, config
+except ImportError:
+    prog = os.path.basename(sys.argv[0])
+    sys.exit("proteus must be installed to use %s" % prog)
+
+
+def _progress(iterable):
+    if ProgressBar:
+        pbar = ProgressBar(
+            widgets=[SimpleProgress(), Bar(), ETA()])
+    else:
+        pbar = iter
+    return pbar(iterable)
+
+
+def _get_language_codes():
+    Language = Model.get('ir.lang')
+    languages = Language.find([('translatable', '=', True)])
+    for l in languages:
+        yield l.code
+
+
+def get_currencies():
+    Currency = Model.get('currency.currency')
+
+    with config.get_config().set_context(active_test=False):
+        return {c.code: c for c in Currency.find([])}
+
+
+def update_currencies(currencies):
+    print("Update currencies")
+    Currency = Model.get('currency.currency')
+    codes = CurrencyCodes()
+
+    records = []
+    for currency in _progress(pycountry.currencies):
+        code = currency.alpha_3
+        if code in currencies:
+            record = currencies[code]
+        else:
+            record = Currency(code=code)
+        record.name = currency.name
+        record.numeric_code = currency.numeric
+        record.symbol = codes.get_symbol(currency.alpha_3) or currency.alpha_3
+        records.append(record)
+
+    Currency.save(records)
+    return {c.code: c for c in records}
+
+
+def translate_currencies(currencies):
+    Currency = Model.get('currency.currency')
+
+    current_config = config.get_config()
+    for code in _get_language_codes():
+        try:
+            gnutranslation = gettext.translation(
+                'iso4217', pycountry.LOCALES_DIR, languages=[code])
+        except IOError:
+            continue
+        print("Update currencies %s" % code)
+        with current_config.set_context(language=code):
+            records = []
+            for currency in _progress(pycountry.currencies):
+                record = Currency(currencies[currency.alpha_3].id)
+                record.name = gnutranslation.gettext(currency.name)
+                records.append(record)
+            Currency.save(records)
+
+
+def main(database, config_file=None):
+    config.set_trytond(database, config_file=config_file)
+
+    currencies = get_currencies()
+    currencies = update_currencies(currencies)
+    translate_currencies(currencies)
+
+
+if __name__ == '__main__':
+    parser = ArgumentParser()
+    parser.add_argument('-d', '--database', dest='database')
+    parser.add_argument('-c', '--config', dest='config_file',
+        help='the trytond config file')
+
+    args = parser.parse_args()
+    if not args.database:
+        parser.error('Missing database')
+    main(args.database, args.config_file)
diff -r 02664e9b5ec6 modules/currency/setup.py
--- a/modules/currency/setup.py	Mon May 06 15:03:00 2019 +0200
+++ b/modules/currency/setup.py	Wed Jul 24 18:28:49 2019 +0200
@@ -81,6 +81,9 @@
             + ['tryton.cfg', 'view/*.xml', 'locale/*.po', 'icons/*.svg',
             'tests/*.rst']),
         },
+    scripts=[
+        'scripts/trytond_import_currencies',
+        ],
     classifiers=[
         'Development Status :: 5 - Production/Stable',
         'Environment :: Plugins',
@@ -121,6 +124,10 @@
     license='GPL-3',
     python_requires='>=3.5',
     install_requires=requires,
+    extras_require={
+        'data': [
+            'pycountry', 'forex-python', get_require_version('proteus')],
+        },
     dependency_links=dependency_links,
     zip_safe=False,
     entry_points="""
diff -r 02664e9b5ec6 modules/currency/tryton.cfg
--- a/modules/currency/tryton.cfg	Mon May 06 15:03:00 2019 +0200
+++ b/modules/currency/tryton.cfg	Wed Jul 24 18:28:49 2019 +0200
@@ -4,6 +4,5 @@
     ir
     res
 xml:
-    data.xml
     currency.xml
     message.xml
diff -r f9adae254aac modules/party/CHANGELOG
--- a/modules/party/CHANGELOG	Thu Jun 06 10:10:38 2019 +0200
+++ b/modules/party/CHANGELOG	Wed Jul 24 18:28:49 2019 +0200
@@ -1,3 +1,4 @@
+* Replace country and language in address format by codes
 * Add sequence field to contact mechanism form view
 
 Version 5.2.0 - 2019-05-06
diff -r f9adae254aac modules/party/address.py
--- a/modules/party/address.py	Thu Jun 06 10:10:38 2019 +0200
+++ b/modules/party/address.py	Wed Jul 24 18:28:49 2019 +0200
@@ -3,8 +3,8 @@
 'Address'
 from string import Template
 
-from sql import Null
-from sql.conditionals import Case, Coalesce
+from sql.conditionals import Coalesce
+from sql.functions import Substring
 from sql.operators import Concat
 
 from trytond.i18n import gettext
@@ -225,8 +225,8 @@
 class AddressFormat(DeactivableMixin, MatchMixin, ModelSQL, ModelView):
     "Address Format"
     __name__ = 'party.address.format'
-    country = fields.Many2One('country.country', "Country")
-    language = fields.Many2One('ir.lang', "Language")
+    country_code = fields.Char("Country Code", size=2)
+    language_code = fields.Char("Language Code", size=2)
     format_ = fields.Text("Format", required=True,
         help="Available variables (also in upper case):\n"
         "- ${party_name}\n"
@@ -245,8 +245,42 @@
     @classmethod
     def __setup__(cls):
         super(AddressFormat, cls).__setup__()
-        cls._order.insert(0, ('country', 'ASC'))
-        cls._order.insert(1, ('language', 'ASC'))
+        cls._order.insert(0, ('country_code', 'ASC NULLS LAST'))
+        cls._order.insert(1, ('language_code', 'ASC NULLS LAST'))
+
+    @classmethod
+    def __register__(cls, module_name):
+        pool = Pool()
+        Country = pool.get('country.country')
+        Language = pool.get('ir.lang')
+        country = Country.__table__()
+        language = Language.__table__()
+        table = cls.__table__()
+        cursor = Transaction().connection.cursor()
+
+        super().__register__(module_name)
+
+        table_h = cls.__table_handler__()
+
+        # Migration from 5.2: replace country by country_code
+        if table_h.column_exist('country'):
+            query = table.update(
+                [table.country_code],
+                country.select(
+                    country.code,
+                    where=country.id == table.country))
+            cursor.execute(*query)
+            table_h.drop_column('country')
+
+        # Migration from 5.2: replace language by language_code
+        if table_h.column_exist('language'):
+            query = table.update(
+                [table.language_code],
+                language.select(
+                    Substring(language.code, 0, 2),
+                    where=language.id == table.language))
+            cursor.execute(*query)
+            table_h.drop_column('language')
 
     @classmethod
     def default_format_(cls):
@@ -257,11 +291,6 @@
 ${subdivision}
 ${COUNTRY}"""
 
-    @staticmethod
-    def order_language(tables):
-        table, _ = tables[None]
-        return [Case((table.language == Null, 1), else_=0), table.language]
-
     @classmethod
     def create(cls, *args, **kwargs):
         records = super(AddressFormat, cls).create(*args, **kwargs)
@@ -298,24 +327,13 @@
 
     @classmethod
     def get_format(cls, address, pattern=None):
-        pool = Pool()
-        Language = pool.get('ir.lang')
-
         if pattern is None:
             pattern = {}
         else:
             pattern = pattern.copy()
         pattern.setdefault(
-            'country', address.country.id if address.country else None)
-
-        languages = Language.search([
-                ('code', '=', Transaction().language),
-                ], limit=1)
-        if languages:
-            language, = languages
-        else:
-            language = None
-        pattern.setdefault('language', language.id if language else None)
+            'country_code', address.country.code if address.country else None)
+        pattern.setdefault('language', Transaction().language[:2])
 
         key = tuple(sorted(pattern.items()))
         format_ = cls._get_format_cache.get(key)
